--------------------------------------------------------------------------------
-- GLOBALS

Global( "sysItemQualityStyle", {
	[ ITEM_QUALITY_JUNK ] = "Junk",
	[ ITEM_QUALITY_GOODS ] = "Goods",
	[ ITEM_QUALITY_COMMON ] = "Common",
	[ ITEM_QUALITY_UNCOMMON ] = "Uncommon",
	[ ITEM_QUALITY_RARE ] = "Rare",
	[ ITEM_QUALITY_EPIC ] = "Epic",
	[ ITEM_QUALITY_LEGENDARY ] = "Legendary",
	[ ITEM_QUALITY_RELIC ] = "Relic"
	} )

--UIRELATEDTEXTURES NAMING
Global("Class", {
	[ "WARRIOR" ] = "WA",
	[ "NECROMANCER" ] = "NE",
	[ "MAGE" ] = "MA",
	[ "DRUID" ] = "DR",
	[ "PSIONIC" ] = "PS",
	[ "PALADIN" ] = "PA",
	[ "PRIEST" ] = "PR",
	[ "STALKER" ] = "ST",
} )


Global( "UNITS", {} )
Global( "Me", 0 )
Global( "MyLVL", 0 )
Global( "GMS", {} )

Global( "ElemDesc", nil )
Global( "ElemFullDesc", nil )
Global( "ElemShortDesc", nil )
Global( "List", { widget = {}, enemyID = {} } )

----------------------------------------------------
function W( s, wt ) return wt and wt:GetChildChecked( s, true ) or mainForm:GetChildChecked( s, true ) end
function ToWS( s ) return userMods.ToWString( s ) end
function FrWS( ws ) return userMods.FromWString( ws ) end

function Wresize( w, scaleX, scaleY )
	local place = w:GetPlacementPlain()
---place.alignY = 0{number}
---place.sizingY = 0{number}
---place.highPosY = 0{number}
---place.sizeX = 153{number}
---place.sizeY = 58{number}
---place.alignX = 0{number}
---place.posX = 717{number}
---place.sizingX = 0{number}
---place.posY = 34{number}
---place.highPosX = 0{number}
	place.sizeX = place.sizeX * scaleX
	place.sizeY = place.sizeY * scaleY
	w:SetPlacementPlain(place)
end
function Wmove( w, shiftX, shiftY )
	local place = w:GetPlacementPlain()
---place.alignY = 0{number}
---place.sizingY = 0{number}
---place.highPosY = 0{number}
---place.sizeX = 153{number}
---place.sizeY = 58{number}
---place.alignX = 0{number}
---place.posX = 717{number}
---place.sizingX = 0{number}
---place.posY = 34{number}
---place.highPosX = 0{number}
	place.posX = place.posX + shiftX
	place.posY = place.posY + shiftY
	w:SetPlacementPlain(place)
end
------------------
function makeShortW(w, place)
	Wmove(W("txtLevel", w ), -18, -5)
	Wmove(W("txtName", w ), -16, 0)
	Wresize(W("panPortrait", w ), 0.1, 0.1)
	W("panPortrait", w ):Show(false)
	Wresize(W("panClass", w ), 1, 1)
	Wmove(W("panClass", w ), -5, 5)
	local barH = W("barHealth", w)
	local barM = W("barMana", w)
	local bHplace = barH:GetPlacementPlain()
	local bMplace = barM:GetPlacementPlain()
	local sY = math.ceil( (place.sizeY - bHplace.sizeY - bMplace.sizeY)/2 )
	bHplace.posY = sY
	bHplace.alignY = 0
	bHplace.highPosY = 0
	bMplace.highPosY = sY
	bMplace.PosY = 0
	bMplace.alignY = 1
	bHplace.posX = bHplace.posX - 30
	bMplace.posX = bMplace.posX - 30
	barH:SetPlacementPlain(bHplace)
	barM:SetPlacementPlain(bMplace)
end

--------------------------------------------------------------------------------
-- REACTION HANDLERS
--------------------------------------------------------------------------------

-- Protrait Clicked
function OnReactionClickSelectTarget( params )
	local key = params.widget:GetParent():GetName()
	if List.enemyID[key] then
		if object.IsExist( List.enemyID[key] ) then avatar.SelectTarget( List.enemyID[key] ) end
	end
end

--------------------------------------------------------------------------------
-- EVENT HANDLERS
--------------------------------------------------------------------------------

---common.RegisterEventHandler( OnEventSecondTimer, "EVENT_UNIT_HEALTH_CHANGED" ) -- Works only for Party/Raid members & Avatar.
---common.RegisterEventHandler( OnEventSecondTimer, "EVENT_UNIT_MANA_CHANGED" )   -- Works only for Party/Raid members & Avatar.

-- Refreshing Health and Mana bars
function OnHMchanged( widget, ID )
	
	if  not object.IsExist(ID) or object.IsFar( ID ) then return end

	local Percentage
	local Progressbar
	
	Percentage = unit.GetHealthPercentage( ID )
	if Percentage ~= nil then
		Progressbar = W("barHealth", widget):GetPlacementPlain()
		Progressbar.sizeX = math.ceil( 86 * Percentage / 100 ) -- Health bar width, px = 86
		W("barHealth", widget):SetPlacementPlain( Progressbar )
	end
	
	Percentage = unit.GetManaPercentage( ID )
	if Percentage ~= nil then
		Progressbar = W("barMana", widget):GetPlacementPlain()
		Progressbar.sizeX = math.ceil( 84 * Percentage / 100 ) -- Mana bar width, px = 84
		W("barMana", widget):SetPlacementPlain( Progressbar )
	end
end


function OnEventSecondTimer( params )
	---- 

	---      
	local IDshow = {}
	local key = ""
	local widget = nil
	for id in UNITS do ---  : UNITS[params.unitId] = 1
		----   
		IDshow[id] = nil
		if object.IsExist( id ) and not object.IsFar( id ) then
			if unit.GetTarget( id ) == Me then ----      and unit.GetPrimaryTarget( Me ) ~= id then
				---     ----,        :
				IDshow[id] = 1
			end
		else
			UNITS[id] = nil ---   ,   
		end
	end

	---    
	for key, widget in pairs(List.widget) do
		if string.sub(key,1,1) == "e" then ---   
			if List.enemyID[key] then
				---      -  -    
				if not IDshow[List.enemyID[key]] then
					---        
					List.enemyID[key] = nil
					widget:Show(false)
				else
					---    -    
					OnHMchanged( widget,  List.enemyID[key])
				end
			end
		else ---    -    
			widget:Show(false)
		end
	end

	----          
	for key, widget in pairs(List.widget) do
		if string.sub(key,1,1) == "e" then ---   
			if List.enemyID[key] then
			else
				---     -      
				local IDtoShow
				for id in IDshow do
					IDtoShow = id
					for _, idShowed in pairs(List.enemyID) do
						if idShowed == id then
							IDtoShow = nil ---    
							break
						end
					end
					if IDtoShow then break end ---       
				end
				if IDtoShow then
					List.enemyID[key] = IDtoShow
					elementCreate( widget, IDtoShow )
					OnHMchanged( widget,  IDtoShow)
					widget:Show(true)
				end
			end
		end
	end

	------    -        if object.IsExist( id ) then
	if GMS then
		for i = 1,5 do
			key = "g"..i
			widget = List.widget[key]
			---     widget:Show(false)
			if GMS[i] then
				---                 
				if GMS[i].id and object.IsExist( GMS[i].id ) then ---and not object.IsFar( GMS[i].id ) then
					local t = unit.GetTarget( GMS[i].id )
					if t then
						List.enemyID[key] = t
						elementCreate( widget, t )
						OnHMchanged( widget,  t)
						widget:Show(true)
					end
				end
			end
		end
	end

end

--------------------------------------------------------------------------------
-- FUNCTIONS
--------------------------------------------------------------------------------


function elementCreate( widget, ID)
	
	---LogInfo ( widget,ID)
	-- Choosing Name color & Portrait color
	if unit.IsFriend( ID ) then
		--wtLabelName:SetFormat( common.GetAddonRelatedText( "LabelNameG" ) )
		W("txtName", widget):SetClassVal( "colorcode", "Friendly" )
		W("panPortrait", widget):SetBackgroundTexture( common.GetAddonRelatedTexture( "PortraitG" ) )
	elseif unit.IsEnemy( ID ) then
		--wtLabelName:SetFormat( common.GetAddonRelatedText( "LabelNameR" ) )
		W("txtName", widget):SetClassVal( "colorcode", "Aggressive" )
		W("panPortrait", widget):SetBackgroundTexture( common.GetAddonRelatedTexture( "PortraitR" ) )
	else
		--wtLabelName:SetFormat( common.GetAddonRelatedText( "LabelNameY" ) )
		W("txtName", widget):SetClassVal( "colorcode", "Neutral" )
		W("panPortrait", widget):SetBackgroundTexture( common.GetAddonRelatedTexture( "PortraitY" ) )
	end

	W("panClass", widget ):Show(false)
	local unitClass = unit.GetClass(ID)
	if unitClass then
		if Class[unitClass.className] then
			W("panClass", widget ):SetBackgroundTexture( common.GetAddonRelatedTexture( Class[unitClass.className] ) )
			W("panClass", widget ):Show(true)
		end
	end
	----mission.SetPortraitBackgroundTexture( 1, true, W("TotPortrait", widget), ID )
	
	-- Setting Name and Level values
	W("txtName", widget ):SetVal( "value", object.GetName( ID ) )
	----       
	local lvl = unit.GetLevel( ID )
	local lvlDiff = lvl - MyLVL + ITEM_QUALITY_UNCOMMON
	if lvlDiff < ITEM_QUALITY_JUNK then lvlDiff = ITEM_QUALITY_JUNK end
	if lvlDiff > ITEM_QUALITY_RELIC then lvlDiff = ITEM_QUALITY_RELIC end
	W("txtLevel", widget ):SetClassVal( "class", sysItemQualityStyle[ lvlDiff  ] )
	W("txtLevel", widget ):SetVal( "value", common.FormatInt( lvl, "%d" ) )
	
	-- Choosing Mana bar color
	if unit.GetClass( ID ).manaType == MANA_TYPE_MANA then
		W("barMana", widget ):SetBackgroundTexture( common.GetAddonRelatedTexture( "ManaM" ) )
	elseif unit.GetClass( ID ).manaType == MANA_TYPE_ENERGY then
		W("barMana", widget ):SetBackgroundTexture( common.GetAddonRelatedTexture( "ManaE" ) )
	else
		W("barMana", widget ):SetBackgroundTexture( common.GetAddonRelatedTexture( "ManaH" ) )
	end


	-- Refreshing Health and Mana bars
	OnHMchanged( widget, ID )
end


---------------------------------------------------------------------------------------------
-- EVENT HANDLERS
---------------------------------------------------------------------------------------------

function onSpawned( params )

	if not unit.IsFriend(  params.unitId ) then
		UNITS[params.unitId] = 1
	end
end

function onDespawned( params )
	if UNITS[params.unitId] then UNITS[params.unitId] = nil end
end

function OnDead( params )
	if UNITS[params.unitId]  then
	   	if object.IsDead(params.unitId) then
	   		UNITS[params.unitId] = nil		
	   	end
	else
		if not object.IsDead(params.unitId) then onSpawned({unitId = params.unitId}) end
	end
end

function onUnitsChanged( params )
	for _, id in params.spawned do
		onSpawned( { unitId = id } )
	end
	for _, id in params.despawned do
		onDespawned( { unitId = id } )
	end
end

function onGroupChanged()
	GMS = group.GetMembers()
end

function OnEventLevelChanged( pars )
	if pars.unitId == Me then
		MyLVL = unit.GetLevel( Me )
	end
end

--------------------------------------------------------------------------------
-- INITIALIZATION
--------------------------------------------------------------------------------
function onAvatarCreated()
	Me = avatar.GetId()
	OnEventLevelChanged( { unitId = Me } )
	common.RegisterEventHandler( OnEventSecondTimer, "EVENT_SECOND_TIMER" )
	common.RegisterEventHandler( OnEventLevelChanged, "EVENT_UNIT_LEVEL_CHANGED" )
---	common.RegisterEventHandler( OnEventTargetRecomm, "EVENT_AVATAR_TARGET_RECOMMENDED" )

	---    
	local w
	local w_name = ""
	local place = {}
	local offset = 1
	local i = 0
	for row = 0, ROWS-1 do
		for col = 0, COLS-1 do
			i = i + 1
			w_name = "e" .. i
			mainForm:CreateWidgetByDesc( ElemDesc ):SetName( w_name )
			w = W( w_name )
			place = w:GetPlacementPlain()
			place.posX = POS_X + col*(place.sizeX + 0) + offset*OFFSET
			place.posY = POS_Y + row*(place.sizeY + 0)
			w:SetPlacementPlain(place)
			if SIZE == 1 then
				----  
				makeShortW(w, place)
			end
			---   
			List.widget[w_name] = w
			elementCreate( w, Me )
			---w:Show(true)
		end
		offset = offset * -1
	end
	---    
	for i=1, 5 do ---    
		w_name = "g" .. i
		mainForm:CreateWidgetByDesc( ElemDesc ):SetName( w_name )
		w = W( w_name )
		place = w:GetPlacementPlain()
		place.posX = GPOS_X + i*GSHIFT_X
		place.posY = GPOS_Y + i*GSHIFT_Y
		w:SetPlacementPlain(place)
		if SIZE == 1 then
			----  
			makeShortW(w, place)
		end
		---   
		List.widget[w_name] = w
		---w:Show(true)
	end

end

function Init()

---	local filename = PATH .. "config.txt"
---	dofile(filename)


	ElemFullDesc = W("ElemFull"):GetWidgetDesc() ---   
	W( "ElemFull"):DestroyWidget()
	ElemDesc = ElemFullDesc
	if SIZE == 1 then
		ElemShortDesc = W("ElemShort"):GetWidgetDesc() ---   
		W( "ElemShort" ):DestroyWidget()
		ElemDesc = ElemShortDesc
	end


	if avatar.IsExist() then onAvatarCreated() end 	---    /

	-- Reactions
	common.RegisterReactionHandler( OnReactionClickSelectTarget, "left_click" )

	-- Events
--- 	common.RegisterEventHandler(onSpawned, "EVENT_UNIT_SPAWNED" )
---	common.RegisterEventHandler(onDespawned, "EVENT_UNIT_DESPAWNED" )
	common.RegisterEventHandler(onUnitsChanged, "EVENT_UNITS_CHANGED" )
 	common.RegisterEventHandler( onAvatarCreated, "EVENT_AVATAR_CREATED" )
 	common.RegisterEventHandler( OnDead, "EVENT_UNIT_DEAD_CHANGED" )
	
 	common.RegisterEventHandler( onGroupChanged, "EVENT_GROUP_CHANGED" )

end
--------------------------------------------------------------------------------
Init()
--------------------------------------------------------------------------------
